/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.BoardMoveHelper");

dojo.require("com.ibm.jdojo.lang.Exception");
dojo.require("com.ibm.jdojo.lang.JavaScriptException");
dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.common.planning.IProgressService");
dojo.require("com.ibm.team.apt.web.client.util");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.dnd.PlanEditorNativeReferenceDropResponse");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.DropStatusNotifier");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.PlanCellUtils");
dojo.require("com.ibm.team.apt.web.ui.internal.util.DragAndDropContentsException");
dojo.require("com.ibm.team.apt.web.ui.internal.util.DragDropUtil");
dojo.require("com.ibm.team.rtc.foundation.api.ui.essentials.IModificationPolicy");
dojo.require("com.ibm.team.rtc.foundation.api.ui.tags.PrimaryLocationTag");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.NativeDragData");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.ViewEntryDragData");
dojo.require("com.ibm.team.rtc.foundation.web.util.JsonIO");
dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board", "Messages");

var lang= com.ibm.jdojo.lang;
var Exception= lang.Exception;
var JavaScriptException= lang.JavaScriptException;
var jdojo= lang.Runtime;
var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var IPlanItem= api.client.IPlanItem;
var IProgressService= api.common.planning.IProgressService;
var web= apt.web;
var util= web.client.util;
var internal= web.ui.internal;
var viewer4= internal.common.viewer;
var PlanEditorNativeReferenceDropResponse= viewer4.dnd.PlanEditorNativeReferenceDropResponse;
var plan= viewer4.plan;
var DropStatusNotifier= plan.DropStatusNotifier;
var PlanCellUtils= plan.PlanCellUtils;
var util2= internal.util;
var DragAndDropContentsException= util2.DragAndDropContentsException;
var DragDropUtil= util2.DragDropUtil;
var foundation= team.rtc.foundation;
var ui= foundation.api.ui;
var Location= ui.essentials.IModificationPolicy.Location;
var PrimaryLocationTag= ui.tags.PrimaryLocationTag;
var web2= foundation.web;
var dnd= web2.ui.gridviewer.dnd;
var NativeDragData= dnd.NativeDragData;
var ViewEntryDragData= dnd.ViewEntryDragData;
var JsonIO= web2.util.JsonIO;
var string= dojo.string;

/**
 * A class which helps with drag and drop on a board
 */
var BoardMoveHelper= dojo.declare("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.BoardMoveHelper", null, {
	"-chains-": { constructor: "manual" }
});
/**
 * A class used to determine the Move Requests of objects being dropped
 */
var MoveRequest= dojo.declare("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.BoardMoveHelper.MoveRequest", null, {
	"-chains-": { constructor: "manual" },

	//fSource: null,

	//fTargetEntry: null,

	//fLocation: null,

	constructor: function(source, targetEntry, location) {
		this.fSource= source;
		this.fTargetEntry= targetEntry;
		this.fLocation= location;
	},

	getSource: function() {
		return this.fSource;
	},

	getTarget: function() {
		return this.fTargetEntry;
	},

	getLocation: function() {
		return this.fLocation;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.essentials.IMoveHandler.IMoveRequest': true
	}
});

BoardMoveHelper.DRAG_TEXT= "Text";
BoardMoveHelper.DRAG_WORK_ITEM_ID= "WorkItem_ID";
BoardMoveHelper.DRAG_WORK_ITEM_URI= "WorkItem_URI";
BoardMoveHelper.DRAG_WORK_ITEM_STATE= "WorkItem_State";
BoardMoveHelper.DRAG_WORK_ITEM= "WorkItem";
BoardMoveHelper.DRAG_WORK_ITEM_ACTIONS= "WorkItem_Actions";
BoardMoveHelper.DRAG_WORKFLOW_ACTION= "WorkFlow_Action";
BoardMoveHelper.DRAG_WORKFLOW_FINAL_STATE= "WorkFlow_Final_State";
BoardMoveHelper.INVALID_DROP_CSS_CLASS= "invalid-drop";
BoardMoveHelper.START_STATE_CSS_CLASS= "drag-start";
BoardMoveHelper.VALID_DROP_CSS_CLASS= "valid-drop";
BoardMoveHelper.setCrossPlanDragData= function(note, data) {
	var viewModel= BoardMoveHelper.getViewModel(note);
	viewModel.readModel(function(readAccessor) {
		var workItems= readAccessor.getElementEntries(note.getWorkItem());
		var dragData= null;
		var $subject= workItems;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var workItem= $subject[$count];
			if (workItem.hasTag(PrimaryLocationTag.INSTANCE)) {
				dragData= new ViewEntryDragData(([workItem]), viewModel.getViewer());
			}
		}
		if (dragData == null) {
			dragData= new ViewEntryDragData(workItems, viewModel.getViewer());
		}
		var map= DragDropUtil.PlanElementDragDataProvider(dragData);
		if (map != null) {
			var $subject2= jdojo.getProperties(map);
			var $length2= $subject2.length;
			for (var $count2= 0; $count2 < $length2; $count2++){
				var key= $subject2[$count2];
				data.setData(key, map[key]);
			}
		}
		return null;
	});
};
BoardMoveHelper.setDragData= function(planElement, data) {
	var planItem= planElement.getAdapter(IPlanItem);
	if (planItem.getWorkflowState() != null) {
		if (!dojo.isIE) {
			data.setData(BoardMoveHelper.DRAG_TEXT, planItem.getId() + ": " + planItem.getSummary());
		}
		var infoAttribute= planElement.getPlanModel().findAttribute(IPlanItem.WORKFLOW_INFO);
		var info= infoAttribute.getValue(planElement);
		var actions= [];
		var $subject3= info.getActions();
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var actionHandle= $subject3[$count3];
			var action= infoAttribute.getResolvedAction(actionHandle);
			if (action != null) {
				var $subject4= action.getStartStates();
				var $length4= $subject4.length;
				for (var $count4= 0; $count4 < $length4; $count4++){
					var startState= $subject4[$count4];
					if (startState.getItemId() === planItem.getWorkflowState().getItemId()) {
						var actionMap= {};
						actionMap[BoardMoveHelper.DRAG_WORKFLOW_ACTION]= action;
						actionMap[BoardMoveHelper.DRAG_WORKFLOW_FINAL_STATE]= infoAttribute.getResolvedState(action.getEndState());
						actions.push(actionMap);
						break;
					}
				}
			}
		}
		data.setData(BoardMoveHelper.DRAG_WORK_ITEM, planElement);
		data.setData(BoardMoveHelper.DRAG_WORK_ITEM_ID, planItem.getId());
		data.setData(BoardMoveHelper.DRAG_WORK_ITEM_URI, planItem.getUri());
		data.setData(BoardMoveHelper.DRAG_WORK_ITEM_STATE, planItem.getWorkflowState());
		data.setData(BoardMoveHelper.DRAG_WORK_ITEM_ACTIONS, actions);
	}
};
BoardMoveHelper.setDragFeedback= function(gadget, data) {
	var lastRow= null;
	var $subject5= BoardMoveHelper.getViewModel(gadget).getViewer().getAllCells();
	var $length5= $subject5.length;
	for (var $count5= 0; $count5 < $length5; $count5++){
		var cell= $subject5[$count5];
		if (gadget.getParent() === cell) {
			dojo.addClass(cell.getHTMLElement(), BoardMoveHelper.START_STATE_CSS_CLASS);
		}
		if (cell.canDrop(data)) {
			dojo.addClass(cell.getHTMLElement(), BoardMoveHelper.VALID_DROP_CSS_CLASS);
		} else {
			dojo.addClass(cell.getHTMLElement(), BoardMoveHelper.INVALID_DROP_CSS_CLASS);
		}
		if (dojo.isIE) {
			var currentRow= cell.getParent().getRow();
			if (currentRow !== lastRow) {
				cell.setCellHeight();
			}
			lastRow= currentRow;
		}
	}
};
BoardMoveHelper.doesWorkflowContainState= function(gadget, data) {
	var element= data.getData(BoardMoveHelper.DRAG_WORK_ITEM);
	if (element != null) {
		var info= element.getAttributeValue(IPlanItem.WORKFLOW_INFO);
		var $subject6= info.getStates();
		var $length6= $subject6.length;
		for (var $count6= 0; $count6 < $length6; $count6++){
			var dragStateHandle= $subject6[$count6];
			var validStates= gadget.getState(dragStateHandle.getItemId());
			if (validStates != null) {
				return true;
			}
		}
	}
	return false;
};
BoardMoveHelper.getWorkFlowAction= function(gadget, data) {
	var element= data.getData(BoardMoveHelper.DRAG_WORK_ITEM);
	if (element != null) {
		var legalStates= data.getData(BoardMoveHelper.DRAG_WORK_ITEM_ACTIONS);
		if (legalStates != null) {
			var actions= [];
			if (gadget.getState(data.getData(BoardMoveHelper.DRAG_WORK_ITEM_STATE).getItemId()) != null) {
				actions.push(null);
			}
			var $subject7= legalStates;
			var $length7= $subject7.length;
			for (var $count7= 0; $count7 < $length7; $count7++){
				var state= $subject7[$count7];
				if (state != null) {
					if (gadget.getState(state[BoardMoveHelper.DRAG_WORKFLOW_FINAL_STATE].getItemId()) != null) {
						actions.push(state[BoardMoveHelper.DRAG_WORKFLOW_ACTION]);
					}
				}
			}
			return actions;
		}
	}
	return [];
};
BoardMoveHelper.canDrag= function(note) {
	return !note.isReadOnly() && !PlanCellUtils.isPlanItemNew(note.getWorkItem().getAdapter(IPlanItem));
};
BoardMoveHelper.onDrag= function(note, data) {
	BoardMoveHelper.setCrossPlanDragData(note, data);
	BoardMoveHelper.setDragData(note.getWorkItem(), data);
	BoardMoveHelper.setDragFeedback(note, data);
};
BoardMoveHelper.canDropWorkflow= function(gadget, data) {
	return BoardMoveHelper.getWorkFlowAction(gadget, data).length > 0;
};
BoardMoveHelper.doCanDropGroup= function(group, viewModel, data) {
	if (group != null) {
		var viewer= viewModel.getViewer();
		var provider= viewer.getPlanMode().getGroupProvider();
		return viewModel.readModel(function(readAccessor) {
			var workItems= readAccessor.getElementEntries(data.getData(BoardMoveHelper.DRAG_WORK_ITEM));
			if (jdojo.implementsInterface(provider, "com.ibm.team.rtc.foundation.api.ui.essentials.IMoveHandler")) {
				var request= new MoveRequest(workItems, group.getViewEntry(), Location.Child);
				var response= provider.canMove(request, readAccessor);
				if (response == null || response.canMove()) {
					return true;
				}
			}
			return false;
		});
	}
	return true;
};
BoardMoveHelper.canCrossPlanDrop= function(gadget, data) {
	return null;
};
BoardMoveHelper.canDrop= function(gadget, data) {
	if (BoardMoveHelper.getViewer(gadget).isReadOnly()) {
		return Messages.BoardMoveHelper_READ_ONLY;
	}
	var element= data.getData(BoardMoveHelper.DRAG_WORK_ITEM);
	if (element == null) {
		return BoardMoveHelper.canCrossPlanDrop(gadget, data);
	} else {
		if (!BoardMoveHelper.doesWorkflowContainState(gadget, data)) {
			return Messages.BoardMoveHelper_UNSUPPORTED_STATE;
		} else if (!BoardMoveHelper.canDropWorkflow(gadget, data)) {
			return Messages.BoardMoveHelper_UNSUPPORTED_STATE_TRANSITION;
		} else if (!BoardMoveHelper.doCanDropGroup(gadget.getGroup(), BoardMoveHelper.getViewModel(gadget), data)) {
			return Messages.BoardMoveHelper_UNSUPPORTED_GROUP_TRANSITION;
		}
		return null;
	}
};
BoardMoveHelper.canDropGroup= function(group, data) {
	if (BoardMoveHelper.getViewer(group.getBoard()).isReadOnly()) {
		return Messages.BoardMoveHelper_READ_ONLY;
	}
	var element= data.getData(BoardMoveHelper.DRAG_WORK_ITEM);
	if (element == null) {
		return BoardMoveHelper.canCrossPlanDrop(group, data);
	} else {
		if (!BoardMoveHelper.doCanDropGroup(group, group.getViewModel(), data)) {
			return Messages.BoardMoveHelper_UNSUPPORTED_GROUP_TRANSITION;
		}
		return null;
	}
};
BoardMoveHelper.canPlanDrop= function(gadget, data) {
	if (BoardMoveHelper.getViewer(gadget).isReadOnly()) {
		return Messages.BoardMoveHelper_READ_ONLY;
	}
	return BoardMoveHelper.canCrossPlanDrop(gadget, data);
};
BoardMoveHelper.canDropPlan= function(gadget, data) {
	if (BoardMoveHelper.getViewer(gadget).isReadOnly()) {
		return Messages.BoardMoveHelper_READ_ONLY;
	}
	return BoardMoveHelper.canCrossPlanDrop(gadget, data);
};
BoardMoveHelper.setWorkflowAction= function(updateAccessor, gadget, data) {
	var actions= BoardMoveHelper.getWorkFlowAction(gadget, data);
	if (actions.length > 0) {
		var element= gadget.getModel().getPlanElementByUri(data.getData(BoardMoveHelper.DRAG_WORK_ITEM_URI));
		var oldAction= element.getAttributeValue(IPlanItem.WORKFLOW_ACTION);
		if ((oldAction == null && actions[0] != null) || (oldAction != null && actions[0] == null) || ((oldAction != null && actions[0] != null) && (oldAction.getId() !== actions[0].getId()))) {
			element.setAttributeValue(IPlanItem.WORKFLOW_ACTION, actions[0]);
		}
	}
};
BoardMoveHelper.setGroup= function(updateAccessor, group, viewModel, data) {
	if (group != null) {
		var element= data.getData(BoardMoveHelper.DRAG_WORK_ITEM);
		if (element != null) {
			var viewer= viewModel.getViewer();
			var provider= viewer.getPlanMode().getGroupProvider();
			var workItems= updateAccessor.getElementEntries(element);
			var request= new MoveRequest(workItems, group.getViewEntry(), Location.Child);
			var response= provider.canMove(request, updateAccessor);
			if (response != null && response.canMove()) {
				provider.move(response, updateAccessor);
			}
		}
	}
};
BoardMoveHelper.getDropResponse= function(data) {
	var notifier= new DropStatusNotifier();
	return new PlanEditorNativeReferenceDropResponse(new NativeDragData(data.getEvent()), Location.Child, notifier);
};
BoardMoveHelper.setPlan= function(updateAccessor, gadget, data) {
	var planModel= gadget.getModel();
	var viewModel= BoardMoveHelper.getViewModel(gadget);
	BoardMoveHelper.doSetPlan(updateAccessor, planModel, viewModel, data, null);
};
BoardMoveHelper.setPlanFromGroup= function(updateAccessor, group, data) {
	var planModel= group.getPlanModel();
	var viewModel= group.getViewModel();
	BoardMoveHelper.doSetPlan(updateAccessor, planModel, viewModel, data, null);
};
BoardMoveHelper.doSetPlan= function(updateAccessor, planModel, viewModel, data, updateFunction) {
	var dropResponse= BoardMoveHelper.getDropResponse(data);
	var viewer= viewModel.getViewer();
	var planningAttributeDependent= viewer.getPlanningAttributeDependent();
	if (planningAttributeDependent != null) {
		dropResponse.apply(null, planModel, null, viewModel, planningAttributeDependent, planningAttributeDependent.getPlanEditor().getService(IProgressService), function(result) {
			try {
				if (updateFunction != null) {
					viewModel.updateModel(updateFunction);
				}
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
					if (util.isDebugMode()) {
						console.debug(string.substitute("Error handling native drop: ${0}", [JsonIO.stringify(e) ]));
					}
					var message= (e instanceof DragAndDropContentsException) ? e.getMessage() : Messages.BoardMoveHelper_UNABLE_TO_HANDLE_DROP;
					new DropStatusNotifier().showDropNotification(message);
				} else {
					throw e;
				}
			}
		});
	}
};
BoardMoveHelper.onDrop= function(gadget, data) {
	BoardMoveHelper.getViewModel(gadget).updateModel(function(updateAccessor) {
		var element= data.getData(BoardMoveHelper.DRAG_WORK_ITEM);
		if (element != null) {
			BoardMoveHelper.setWorkflowAction(updateAccessor, gadget, data);
			BoardMoveHelper.setGroup(updateAccessor, gadget.getGroup(), BoardMoveHelper.getViewModel(gadget), data);
		} else {
			BoardMoveHelper.setPlan(updateAccessor, gadget, data);
		}
		return null;
	});
};
BoardMoveHelper.onDropGroup= function(group, viewModel, data) {
	viewModel.updateModel(function(updateAccessor) {
		var element= data.getData(BoardMoveHelper.DRAG_WORK_ITEM);
		if (element != null) {
			BoardMoveHelper.setGroup(updateAccessor, group, viewModel, data);
		} else {
			BoardMoveHelper.setPlanFromGroup(updateAccessor, group, data);
		}
		return null;
	});
};
BoardMoveHelper.onPlanDrop= function(gadget, data) {
	BoardMoveHelper.getViewModel(gadget).updateModel(function(updateAccessor) {
		var planModel= gadget.getModel();
		var viewModel= BoardMoveHelper.getViewModel(gadget);
		BoardMoveHelper.doSetPlan(updateAccessor, planModel, viewModel, data, null);
		return null;
	});
};
BoardMoveHelper.onDropPlan= function(gadget, data) {
	BoardMoveHelper.getViewModel(gadget).updateModel(function(updateAccessor) {
		var planModel= gadget.getModel();
		var viewModel= BoardMoveHelper.getViewModel(gadget);
		BoardMoveHelper.doSetPlan(updateAccessor, planModel, viewModel, data, null);
		return null;
	});
};
BoardMoveHelper.onDragEnd= function(gadget, data) {
	var $subject8= BoardMoveHelper.getViewModel(gadget).getViewer().getAllCells();
	var $length8= $subject8.length;
	for (var $count8= 0; $count8 < $length8; $count8++){
		var cell= $subject8[$count8];
		dojo.removeClass(cell.getHTMLElement(), BoardMoveHelper.START_STATE_CSS_CLASS);
		dojo.removeClass(cell.getHTMLElement(), BoardMoveHelper.VALID_DROP_CSS_CLASS);
		dojo.removeClass(cell.getHTMLElement(), BoardMoveHelper.INVALID_DROP_CSS_CLASS);
	}
};
BoardMoveHelper.getViewModel= function(gadget) {
	while(gadget != null && !(jdojo.implementsInterface(gadget.getParent(), "com.ibm.team.rtc.foundation.web.ui.model.IViewModelViewer")) && (jdojo.implementsInterface(gadget.getParent(), "com.ibm.team.rtc.foundation.web.ui.gadgets.IHTMLGadget"))){
		gadget= gadget.getParent();
	}
	if (jdojo.implementsInterface(gadget.getParent(), "com.ibm.team.rtc.foundation.web.ui.model.IViewModelViewer")) {
		return gadget.getParent().getViewModel();
	}
	return null;
};
BoardMoveHelper.getViewer= function(gadget) {
	while(gadget != null && !(jdojo.implementsInterface(gadget.getParent(), "com.ibm.team.rtc.foundation.web.ui.model.IViewModelViewer")) && (jdojo.implementsInterface(gadget.getParent(), "com.ibm.team.rtc.foundation.web.ui.gadgets.IHTMLGadget"))){
		gadget= gadget.getParent();
	}
	if (jdojo.implementsInterface(gadget.getParent(), "com.ibm.team.rtc.foundation.web.ui.model.IViewModelViewer")) {
		return gadget.getParent();
	}
	return null;
};

})();
