/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.kanban.KanbanViewer");

dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanElement");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.AbstractBoardViewer");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.CardColorizer");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.CardMenuCreator");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.CardOutplacedMarker");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.TaskNote");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.kanban.KanbanBoard");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableColumn");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.kanban", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.kanban", "Messages");

var team= com.ibm.team;
var apt= team.apt;
var PlanElement= apt.shared.client.internal.model.PlanElement;
var board= apt.web.ui.internal.common.viewer.plan.board;
var AbstractBoardViewer= board.AbstractBoardViewer;
var CardColorizer= board.CardColorizer;
var CardMenuCreator= board.CardMenuCreator;
var CardOutplacedMarker= board.CardOutplacedMarker;
var TaskNote= board.TaskNote;
var KanbanBoard= board.kanban.KanbanBoard;
var TableColumn= team.rtc.foundation.web.ui.gadgets.table.TableColumn;

/**
 * The ViewModelViewer which links a Kanban Board to its model
 */
dojo.declare("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.kanban.KanbanViewer", AbstractBoardViewer, {

	/**
	 * A basic constructor
	 * 
	 * @param plan
	 *            The plan item tab which provided the columns and the model
	 */
	constructor: function(abstractBoardViewerParamters) {
		this.inherited(arguments, [abstractBoardViewerParamters]);
	},

	instantiateBoard: function(id, model) {
		return new KanbanBoard(id, model);
	},

	createTaskNote: function(workItem, cardSizeManager, attributes, workItemEntry) {
		return new TaskNote(workItem, cardSizeManager, attributes, CardColorizer.fromEntry(workItemEntry), CardMenuCreator.fromEntry(workItemEntry, this.getPlanningAttributeDependent(), this.getServiceProvider()), CardOutplacedMarker.fromEntry(workItemEntry));
	},

	/**
	 * Adds a task note to a kanban board
	 * 
	 * @param readAccessor
	 *            Is used to help retrieve elements
	 * @param stateEntry
	 *            The state to add the task note under
	 * @param workItemEntry
	 *            The task note to add
	 */
	addTaskNote: function(readAccessor, stateTreeElement, workItemEntry) {
		if (stateTreeElement.getData().gadget instanceof TableColumn && workItemEntry.getElement() instanceof PlanElement) {
			var group= null;
			var stateColumn= stateTreeElement.getData().gadget;
			if (stateColumn.getParentColumn() != null) {
				group= stateColumn.getTable().getParent();
			} else {
				var stateGroupColumn= stateColumn;
				group= stateGroupColumn.getTable().getParent();
				var stateGroup= stateGroupColumn.getData();
				var state= this.getState(workItemEntry);
				if (this.getBoardConfigurations().isStateGroupHidingStates(stateGroup)) {
					stateColumn= group.getState(null, stateGroup);
				} else {
					stateColumn= group.getState(state, stateGroup);
				}
			}
			stateTreeElement.addChildAtEnd(workItemEntry.getIdentifier(), {viewEntry: workItemEntry, gadget: this.addTask(readAccessor, group, stateColumn, group.getRow(), workItemEntry)});
		} else {
			console.error(Messages.KanbanViewer_UNEXPECTED_TYPE_ADD_TASK_NOTE);
		}
	},

	addElement: function(readAccessor, parentTreeElement, viewEntry) {
		if (viewEntry.getElement() instanceof PlanElement) {
			if (this.isViewEntryVisible(viewEntry)) {
				this.addTaskNote(readAccessor, parentTreeElement, viewEntry);
			}
		} else {
			this.inherited("addElement", arguments, [readAccessor, parentTreeElement, viewEntry]);
		}
	}
});

})();
