/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.taskboard.TaskboardViewer");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanElement");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.AbstractBoardViewer");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.CardColorizer");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.CardMenuCreator");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.CardOutplacedMarker");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.taskboard.Taskboard");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.taskboard.TaskboardTaskNote");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableColumn");

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var team= com.ibm.team;
var apt= team.apt;
var PlanElement= apt.shared.client.internal.model.PlanElement;
var board2= apt.web.ui.internal.common.viewer.plan.board;
var AbstractBoardViewer= board2.AbstractBoardViewer;
var CardColorizer= board2.CardColorizer;
var CardMenuCreator= board2.CardMenuCreator;
var CardOutplacedMarker= board2.CardOutplacedMarker;
var taskboard= board2.taskboard;
var Taskboard= taskboard.Taskboard;
var TaskboardTaskNote= taskboard.TaskboardTaskNote;
var TableColumn= team.rtc.foundation.web.ui.gadgets.table.TableColumn;

/**
 * The ViewModelViewer which links a Taskboard to its model
 */
var TaskboardViewer= dojo.declare("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.taskboard.TaskboardViewer", AbstractBoardViewer, {

	/**
	 * A basic constructor
	 * 
	 * @param plan
	 *            The plan item tab which provided the columns and the model
	 */
	constructor: function(abstractBoardViewerParamters) {
		this.inherited(arguments, [abstractBoardViewerParamters]);
	},

	instantiateBoard: function(id, model) {
		return new Taskboard(id, model);
	},

	createTaskNote: function(workItem, cardSizeManager, attributes, workItemEntry) {
		return new TaskboardTaskNote(workItem, cardSizeManager, attributes, CardColorizer.fromEntry(workItemEntry), CardMenuCreator.fromEntry(workItemEntry, this.getPlanningAttributeDependent(), this.getServiceProvider()), CardOutplacedMarker.fromEntry(workItemEntry));
	},

	/**
	 * Add a story to the taskboard view
	 * 
	 * @param readAccessor
	 *            Is used to help retrieve elements
	 * @param groupEntry
	 *            The group to add the story under
	 * @param storyEntry
	 *            The story to add
	 */
	addStory: function(readAccessor, groupTreeElement, storyEntry) {
		if (groupTreeElement.getData().gadget == null && groupTreeElement.getParent() == null) {
			groupTreeElement.getData().gadget= this.createBoard(null, this.getPlanModel());
		}
		if (groupTreeElement.getData().gadget instanceof Taskboard && jdojo.implementsInterface(storyEntry.getElement(), "com.ibm.team.apt.api.ui.structure.ITaskboardItemContainer")) {
			var group= groupTreeElement.getData().gadget;
			var story= this.getPlanElement(storyEntry);
			groupTreeElement.addChildAtEnd(storyEntry.getIdentifier(), {viewEntry: storyEntry, gadget: group.addStory(story)});
			this.evaluateViewEntry(readAccessor, storyEntry);
		} else {
			console.error(TaskboardViewer.TaskboardViewer_UNEXPECTED_TYPE_ADD_STORY);
		}
	},

	/**
	 * Adds a task note to a taskboard
	 * 
	 * @param readAccessor
	 *            Is used to help retrieve elements
	 * @param storyEntry
	 *            The story to add the task note under
	 * @param stateEntry
	 *            The state to add the task note under
	 * @param workItemEntry
	 *            The task note to add
	 */
	addTaskNote: function(readAccessor, stateTreeElement, workItemEntry) {
		if (stateTreeElement.getData().gadget instanceof TableColumn && workItemEntry.getElement() instanceof PlanElement) {
			var group= null;
			var stateColumn= stateTreeElement.getData().gadget;
			var storyRow= null;
			if (stateColumn.getParentColumn() != null) {
				group= stateColumn.getTable().getParent();
				storyRow= stateTreeElement.getParent().getParent().getData().gadget;
			} else {
				var stateGroupColumn= stateColumn;
				group= stateGroupColumn.getTable().getParent();
				storyRow= stateTreeElement.getParent().getData().gadget;
				var stateGroup= stateGroupColumn.getData();
				if (!(jdojo.implementsInterface(stateGroup, "com.ibm.team.apt.api.common.workitem.IWorkflowStateGroup"))) {
					stateColumn= stateGroupColumn;
				} else {
					var state= this.getState(workItemEntry);
					if (this.getBoardConfigurations().isStateGroupHidingStates(stateGroup)) {
						stateColumn= group.getState(null, stateGroup);
					} else {
						stateColumn= group.getState(state, stateGroup);
					}
				}
			}
			stateTreeElement.addChildAtEnd(workItemEntry.getIdentifier(), {viewEntry: workItemEntry, gadget: this.addTask(readAccessor, group, stateColumn, storyRow, workItemEntry)});
		} else {
			console.error(TaskboardViewer.TaskboardViewer_UNEXPECTED_TYPE_ADD_TASK_NOTE);
		}
	},

	isViewEntryVisible: function(viewEntry) {
		if (viewEntry.getElement() instanceof PlanElement) {
			if (viewEntry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
				var parentViewEntry= readAccessor.getParent(viewEntry);
				var treeEntry= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(parentViewEntry.getIdentifier());
				if (treeEntry != null) {
					var column= treeEntry.getData().gadget;
					if (column instanceof TableColumn) {
						var board= column.getTable().getParent();
						if (column !== board.getStoryColumn() && column.getParentColumn() !== board.getStoryColumn()) {
							return false;
						}
						return true;
					}
				}
				return false;
			}))) {
				return true;
			}
		}
		return this.inherited("isViewEntryVisible", arguments, [viewEntry]);
	},

	addElement: function(readAccessor, parentTreeElement, viewEntry) {
		if (jdojo.implementsInterface(viewEntry.getElement(), "com.ibm.team.apt.api.ui.structure.ITaskboardItemContainer")) {
			this.addStory(readAccessor, parentTreeElement, viewEntry);
		} else if (viewEntry.getElement() instanceof PlanElement) {
			if (this.isViewEntryVisible(viewEntry)) {
				this.addTaskNote(readAccessor, parentTreeElement, viewEntry);
			}
		} else {
			this.inherited("addElement", arguments, [readAccessor, parentTreeElement, viewEntry]);
		}
	}
});

TaskboardViewer.TaskboardViewer_UNEXPECTED_TYPE_ADD_STORY= "Unexpected Type: addStory";
TaskboardViewer.TaskboardViewer_UNEXPECTED_TYPE_ADD_TASK_NOTE= "Unexpected Type: addTaskNote";

})();
