/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.util.sprite.OverlayImage"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.util.sprite.DomNodeSpriteImage"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

(function() {
var DomNodeSpriteImage= com.ibm.team.rtc.foundation.web.ui.util.sprite.DomNodeSpriteImage;
var string= dojo.string;

var OverlayImage= dojo.declare("com.ibm.team.rtc.foundation.web.ui.util.sprite.OverlayImage", DomNodeSpriteImage, { //$NON-NLS-1$

	//fTopLeft: null,

	//fTopRight: null,

	//fBottomLeft: null,

	//fBottomRight: null,

	//fDimming: null,

	constructor: function(base, topLeft, topRight, bottomLeft, bottomRight, dimming) {
		this.inherited(arguments, [base]);
		this.fTopLeft= topLeft;
		this.fTopRight= topRight;
		this.fBottomLeft= bottomLeft;
		this.fBottomRight= bottomRight;
		this.fDimming= dimming;
	},

	resolveSpriteDomNode: function(imgUri, info, targetDomNode) {
		var baseDomNode= dojo.create("span", {}); //$NON-NLS-1$
		baseDomNode.style.display= "inline-block"; //$NON-NLS-1$
		targetDomNode.style.position= "relative"; //$NON-NLS-1$
		if (this.fDimming) {
			baseDomNode.style.filter= string.substitute(OverlayImage.ALPHA_FILTER_TEMPLATE, [100 * OverlayImage.DIM_OPACITY ]);
			baseDomNode.style["mozOpacity"]= String(OverlayImage.DIM_OPACITY); //$NON-NLS-1$
			baseDomNode.style["opacity"]= String(OverlayImage.DIM_OPACITY); //$NON-NLS-1$
		}
		dojo.place(baseDomNode, targetDomNode);
		this.placeOverlay(this.fTopLeft, true, false, false, true, targetDomNode);
		this.placeOverlay(this.fTopRight, true, true, false, false, targetDomNode);
		this.placeOverlay(this.fBottomLeft, false, false, true, true, targetDomNode);
		this.placeOverlay(this.fBottomRight, false, true, true, false, targetDomNode);
		this.inherited("resolveSpriteDomNode", arguments, [imgUri, info, baseDomNode]); //$NON-NLS-1$
	},

	placeOverlay: function(source, top, right, bottom, left, target) {
		if (source != null) {
			var node= source.getDomNode();
			node.style.position= "absolute"; //$NON-NLS-1$
			if (top) {
				node.style.top= String(0);
			}
			if (right) {
				node.style.right= String(0);
			}
			if (bottom) {
				node.style.bottom= String(0);
			}
			if (left) {
				node.style.left= String(0);
			}
			dojo.place(node, target);
		}
	},

	fetch: function() {
		if (this.fTopLeft != null) 
			this.fTopLeft.fetch();
		if (this.fTopRight != null) 
			this.fTopRight.fetch();
		if (this.fBottomLeft != null) 
			this.fBottomLeft.fetch();
		if (this.fBottomRight != null) 
			this.fBottomRight.fetch();
		return this.inherited("fetch", arguments, []); //$NON-NLS-1$
	},

	onDomNodeSize: function(targetDomNode, width, height) {
		this.inherited("onDomNodeSize", arguments, [targetDomNode, width, height]); //$NON-NLS-1$
		this.fDomNode.style.width= width + DomNodeSpriteImage.PIXELS;
		this.fDomNode.style.height= height + DomNodeSpriteImage.PIXELS;
	}
});

OverlayImage.DIM_OPACITY= 0.5;
OverlayImage.ALPHA_FILTER_TEMPLATE= "alpha(opacity=${0})"; //$NON-NLS-1$

})();
